<?php
/*--------------------------------------------
* Add Icon font to CPT menu
---------------------------------------------*/
function spp_lch_cptmenuicon() {
	?>
	<style type="text/css">
		#adminmenu #menu-posts-spp_lch_popups div.wp-menu-image:before {
			font-family: pm-lastchance !important;
			content: '\e80e';
		}
	</style>
	<?
}
add_action( 'admin_head', 'spp_lch_cptmenuicon' );

add_filter('wp_footer', 'spp_lch_deliver_popups', 100);
function spp_lch_deliver_popups( ){
	global $post;
	global $spp_lch_options;
	$spp_lch_showthis = get_post_meta( $post->ID, 'spp_lch_showthis', true );
	
	if( is_front_page() && $spp_lch_options['home_lchpopup'] ){
		$spp_lch_ad_post = get_post( $spp_lch_options['home_lchpopup'] );
		$used_id = $spp_lch_options['home_lchpopup'];		
		$to_show = 1;
	}
	
	if( ( is_archive() || is_category() ) && $spp_lch_options['archive_lchpopup'] ){
		$spp_lch_ad_post = get_post( $spp_lch_options['archive_lchpopup'] );
		$used_id = $spp_lch_options['archive_lchpopup'];
		$to_show = 1;
	}
	
	if ( is_single() && $spp_lch_options['default_lchpopup'] != '0' ) { // Is global ad on?
		if( get_post_meta( $post->ID, 'spp_lch_single_hide', true ) != '1' ) { // Is enabled
			if( !empty( $spp_lch_showthis ) ) {
				// Use ad in this post
				$used_id = get_post_meta( $post->ID, 'spp_lch_showthis', true );
				$spp_lch_ad_post = get_post( get_post_meta( $post->ID, 'spp_lch_showthis', true ) );
			} else {		
				//use default
				$used_id = $spp_lch_options['default_lchpopup'];
				$spp_lch_ad_post = get_post( $spp_lch_options['default_lchpopup'] );
			}
			$to_show = 1;
		} 
	}

	if ( is_page() && $spp_lch_options['page_lchpopup'] != '0' ) { // Is global ad on?
		if( get_post_meta( $post->ID, 'spp_lch_single_hide', true ) != '1' ) { // Is enabled
			if( !empty( $spp_lch_showthis ) ) {
				// Use ad in this post
				$used_id = get_post_meta( $post->ID, 'spp_lch_showthis', true );
				$spp_lch_ad_post = get_post( get_post_meta( $post->ID, 'spp_lch_showthis', true ) );
			} else {				
				//use default
				$used_id = $spp_lch_options['page_lchpopup'];
				$spp_lch_ad_post = get_post( $spp_lch_options['page_lchpopup'] );
			}
			$to_show = 1;
		} 
	}	

	if( $to_show == 1   ) {
		$spp_lch_category = get_the_category($post->ID);
		
		if( get_post_type( $post->ID ) == 'spp_lch_popups' ) {
			$current_ad = get_post_meta( $post->ID, '_spp_lch_post_meta', true );
			$used_id = $post->ID;
			$post_content = $post->post_content;
		} else {
			$post_content = $spp_lch_ad_post->post_content;
		}

		// Get Individual popup meta
		$spp_lch_ind_opts = get_post_meta( $used_id, '_spp_lch_post_meta', true );
		// Set variables
		$frobs = ( $spp_lch_ind_opts['frobs'] >= '0' ) ? $spp_lch_ind_opts['frobs'] : $spp_lch_options['frobs'] ;
		$frobc = ( empty( $spp_lch_ind_opts['frobc'] ) ) ? sanitize_text_field($spp_lch_options['frobc']) : sanitize_text_field($spp_lch_ind_opts['frobc']) ;
		$frobstyle = ( empty( $spp_lch_ind_opts['frobstyle'] ) ) ? sanitize_text_field($spp_lch_options['frobstyle']) : sanitize_text_field($spp_lch_ind_opts['frobstyle']) ;
		$frobgc = ( empty( $spp_lch_ind_opts['frobgc'] ) ) ? sanitize_text_field($spp_lch_options['frobgc']) : sanitize_text_field($spp_lch_ind_opts['frobgc']) ;
		$frobgi = ( empty( $spp_lch_ind_opts['frobgi'] ) ) ? sanitize_text_field($spp_lch_options['frobgi']) : sanitize_text_field($spp_lch_ind_opts['frobgi']) ;
		$frobgp = ( empty( $spp_lch_ind_opts['frobgp'] ) ) ? sanitize_text_field($spp_lch_options['frobgp']) : sanitize_text_field($spp_lch_ind_opts['frobgp']) ;
		$fribs = ( $spp_lch_ind_opts['fribs'] >= '0' ) ? $spp_lch_ind_opts['fribs'] : $spp_lch_options['fribs'] ;
		$fribc = ( empty( $spp_lch_ind_opts['fribc'] ) ) ? sanitize_text_field($spp_lch_options['fribc']) : sanitize_text_field($spp_lch_ind_opts['fribc']) ;
		$fribstyle = ( empty( $spp_lch_ind_opts['fribstyle'] ) ) ? sanitize_text_field($spp_lch_options['fribstyle']) : sanitize_text_field($spp_lch_ind_opts['fribstyle']) ;
		$fribgc = ( empty( $spp_lch_ind_opts['fribgc'] ) ) ? sanitize_text_field($spp_lch_options['fribgc']) : sanitize_text_field($spp_lch_ind_opts['fribgc']) ;
		$fribgi = ( empty( $spp_lch_ind_opts['fribgi'] ) ) ? sanitize_text_field($spp_lch_options['fribgi']) : sanitize_text_field($spp_lch_ind_opts['fribgi']) ;
		$fribgp = ( empty( $spp_lch_ind_opts['fribgp'] ) ) ? sanitize_text_field($spp_lch_options['fribgp']) : sanitize_text_field($spp_lch_ind_opts['fribgp']) ;
		$fribgopacity = ( empty( $spp_lch_ind_opts['fribgopacity'] ) ) ? sanitize_text_field($spp_lch_options['fribgopacity']) : sanitize_text_field($spp_lch_ind_opts['fribgopacity']) ;
		$frtxtc = ( empty( $spp_lch_ind_opts['frtxtc'] ) ) ? sanitize_text_field($spp_lch_options['frtxtc']) : sanitize_text_field($spp_lch_ind_opts['frtxtc']) ;

		$ext = ( $fribgopacity == 0 ) ? 'jpg' : 'png' ;
		$rgb = hex2rgb($fribgc);
		$innerbgcolor = ( $fribgopacity == 0 ) ? $fribgc : 'rgba('.$rgb.', 0.7)' ;

		$bordersize = ( empty($frobs) ) ? '' : 'border-width:'.$frobs.'px; ' ;
		$bordercolor = ( empty($frobc) ) ? '' : 'border-color:'.$frobc.'; ' ;
		$borderstyle = ( empty($frobstyle) ) ? '' : 'border-style:'.$frobstyle.'; ' ;
		$backgroundcolor = ( empty($frobgc) ) ? '' : 'background-color:'.$frobgc.'; ';
		$backgroundimage = ( empty($frobgi) ) ? '' : 'background-image:url(\''.SPP_LCH_DIR.'/modules/images/'.$frobgi.'.jpg\'); ' ;
		$opadding = ( empty($frobgp) ) ? '' : 'padding:'.$frobgp.'px; ' ;
		$ibordersize = ( empty($fribs) ) ? '' : 'border-width:'.$fribs.'px; ' ;
		$ibordercolor = ( empty($fribc) ) ? '' : 'border-color:'.$fribc.'; ' ;
		$iborderstyle = ( empty($fribstyle) ) ? '' : 'border-style:'.$fribstyle.'; ' ;
		$ibackgroundcolor = ( empty($fribgc) ) ? '' : 'background-color:'.$innerbgcolor.'; ';
		$ibackgroundimage = ( empty($fribgi) ) ? '' : 'background-image:url(\''.SPP_LCH_DIR.'/modules/images/'.$fribgi.'.'.$ext.'\'); ' ;
		$ipadding = ( empty($fribgp) ) ? '' : 'padding:'.$fribgp.'px; ' ;
		$textcolor = ( empty($frtxtc) ) ? '' : 'color:'.$frtxtc.'; ' ;

		// Check if cookie exists and whether to ignore
		if( !isset($_COOKIE['spp_lch_popups_hide']) || $spp_lch_options['cookie'] == 1 ) {
			
		?>		
		<div class="spp-lch-exit mfp-hide" style="<?php echo $bordersize.$bordercolor.$borderstyle.$backgroundcolor.$backgroundimage.$opadding; ?>">
			<div class="spp-lch-exit-content" style="<?php echo $ibordersize.$ibordercolor.$iborderstyle.$ibackgroundcolor.$ibackgroundimage.$ibackgroundopacity.$textcolor.$ipadding; ?>">
				<?php
				if(!empty($post_content)) {
				echo wpautop( $post_content, $br = true );
				} ?>
			</div>
		</div>
		<?php
		} // End cookie check	
		
	}
}

// Displays special template for custom post type preview
function spp_lch_show_preview_poponscroll($template) {
	global $post;
	$post_type = get_post_type( $post );

	if ($post_type == 'spp_lch_popups') {
		$template = SPP_LCH_PATH.'/modules/spp_lch_cpt_template.php';
	}
	
	return $template;
}
add_filter( 'template_include', 'spp_lch_show_preview_poponscroll' );

// Convert Hex Color to RGB
function hex2rgb($hex) {
   $hex = str_replace("#", "", $hex);

if(strlen($hex) == 3) {
      $r = hexdec(substr($hex,0,1).substr($hex,0,1));
      $g = hexdec(substr($hex,1,1).substr($hex,1,1));
      $b = hexdec(substr($hex,2,1).substr($hex,2,1));
   } else {
      $r = hexdec(substr($hex,0,2));
      $g = hexdec(substr($hex,2,2));
      $b = hexdec(substr($hex,4,2));
   }

   $carray = array($r, $g, $b);
   $rgb = $carray[0].', '.$carray[1].', '.$carray[2];
   //return implode(",", $rgb); // returns the rgb values separated by commas
   return $rgb; // returns an array with the rgb values
}
?>