<?php
add_action( 'add_meta_boxes', 'spp_lch_add_custom_box' );
function spp_lch_add_custom_box() {
	// Gets all post types
	$post_types = get_post_types( array('public' => true) );
	unset($post_types['attachment'], $post_types['spp_lch_popups'] ); //Removes attachments from post_types array

	// Load metabox for all post types
	foreach ($post_types as $post_type) {
		add_meta_box( 
			'spp_lch_page_settings',
			__( 'Last Chance', 'spp_lastchance' ),
			'spp_lch_single_page_callback',
			$post_type, 'side'
		);
	}
		add_meta_box( 
			'spp_lch_cpt_meta_opts',
			__( 'Popup Design', 'spp_lastchance' ),
			'spp_lch_design_meta',
			'spp_lch_popups'
		);
}

function spp_lch_design_meta( $post ) {
		$spp_lch_meta = get_post_meta( $post->ID, '_spp_lch_post_meta', true );
		
		$frobs = ( empty($spp_lch_meta['frobs'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['frobs'] ) ;
		$frobc = ( empty($spp_lch_meta['frobc'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['frobc'] ) ;
		$frobstyle = ( empty( $spp_lch_meta['frobstyle'] ) ) ? '' : $spp_lch_meta['frobstyle'] ;
		$frobgc = ( empty( $spp_lch_meta['frobgc'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['frobgc'] ) ;
		$frobgi = ( empty( $spp_lch_meta['frobgi'] ) ) ? '' : $spp_lch_meta['frobgi'];
		$frobgp = ( empty( $spp_lch_meta['frobgp'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['frobgp'] );
		$fribs = ( empty($spp_lch_meta['fribs'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['fribs'] ) ;
		$fribc = ( empty($spp_lch_meta['fribc'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['fribc'] ) ;
		$fribstyle = ( empty( $spp_lch_meta['fribstyle'] ) ) ? '' : $spp_lch_meta['fribstyle'];
		$fribgc = ( empty( $spp_lch_meta['fribgc'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['fribgc'] );
		$fribgi = ( empty( $spp_lch_meta['fribgi'] ) ) ? '' : $spp_lch_meta['fribgi'];
		$fribgp = ( empty( $spp_lch_meta['fribgp'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['fribgp'] );
		$fribgopacity = ( empty( $spp_lch_meta['fribgopacity'] ) ) ? '' : $spp_lch_meta['fribgopacity'];
		$frtxtc = ( empty( $spp_lch_meta['frtxtc'] ) ) ? '' : sanitize_text_field( $spp_lch_meta['frtxtc'] );
		//print_r($spp_lch_meta);

		wp_nonce_field( plugin_basename( __FILE__ ), 'spp_lch_nonce' );
		?>
		<table>
			<tr>
				<td><label>Outer Border</label></td>
				<td>
				<div class="borderopts"><label>Size <input type="text" class="small-text" name="frobs" value="<?php echo $frobs; ?>"></label></div>
				<div class="borderopts"><label>Color <input type="text" class="small-text color-picker" name="frobc" value="<?php echo $frobc; ?>"></label></div>
				<div class="borderopts">
					<label>Style
					<select name="frobstyle">
					<option value="0" <?php selected( $frobstyle, '0', true ); ?>>None</option>
					<option value="solid" <?php selected( $frobstyle, 'solid', true ); ?>>Solid</option>
					<option value="dotted" <?php selected( $frobstyle, 'dotted', true ); ?>>Dotted</option>
					<option value="dashed" <?php selected( $frobstyle, 'dashed', true ); ?>>Dashed</option>
					</select>
					</label>
				</div>
				</td>
			</tr>
			<tr>
				<td><label>Outer Background</label></td>
				<td>
				<div class="backgroundopts"><label>Color <input type="text" class="small-text color-picker" name="frobgc" value="<?php echo $frobgc; ?>"></label></div>
				<div class="backgroundopts"><label>Image</label>
					<select id="frobgi" name="frobgi">
						<option value="0" <?php selected( $frobgi, '0', true ); ?>>None</option>
						<option value="bokeh" <?php selected( $frobgi, 'bokeh', true ); ?>>Bokeh</option>
						<option value="flower" <?php selected( $frobgi, 'flower', true ); ?>>Flower</option>
						<option value="grass" <?php selected( $frobgi, 'grass', true ); ?>>Grass</option>
						<option value="log" <?php selected( $frobgi, 'log', true ); ?>>Log</option>
						<option value="paper" <?php selected( $frobgi, 'paper', true ); ?>>Paper</option>
						<option value="stone" <?php selected( $frobgi, 'stone', true ); ?>>Stone</option>
					</select>
				</div>
				<div class="backgroundopts"><label>Padding <input type="text" class="small-text" name="frobgp" value="<?php echo $frobgp; ?>"></label></div>
				<div class="backgroundopts"><img class="img-preview" src="" alt=""></div>
				</td>
			</tr>
			<tr>
				<td><label>Inner Border</label></td>
				<td>
				<div class="borderopts"><label>Size <input type="text" class="small-text" name="fribs" value="<?php echo $fribs; ?>"></label></div>
				<div class="borderopts"><label>Color <input type="text" class="small-text color-picker" name="fribc" value="<?php echo $fribc; ?>"></label></div>
				<div class="borderopts">
					<label>Style
					<select name="fribstyle">
					<option value="0" <?php selected( $fribstyle, '0', true ); ?>>None</option>
					<option value="solid" <?php selected( $fribstyle, 'solid', true ); ?>>Solid</option>
					<option value="dotted" <?php selected( $fribstyle, 'dotted', true ); ?>>Dotted</option>
					<option value="dashed" <?php selected( $fribstyle, 'dashed', true ); ?>>Dashed</option>
					</select>
					</label>
					</div>
				</td>
			</tr>
			<tr>
				<td><label>Inner Background</label></td>
				<td>
				<div class="backgroundopts"><label>Color <input type="text" class="small-text color-picker" name="fribgc" value="<?php echo $fribgc; ?>"></label></div>
				<div class="backgroundopts"><label>Image</label>
					<select id="fribgi" name="fribgi">
						<option value="0" <?php selected( $fribgi, '0', true ); ?>>None</option>
						<option value="bokeh" <?php selected( $fribgi, 'bokeh', true ); ?>>Bokeh</option>
						<option value="flower" <?php selected( $fribgi, 'flower', true ); ?>>Flower</option>
						<option value="grass" <?php selected( $fribgi, 'grass', true ); ?>>Grass</option>
						<option value="log" <?php selected( $fribgi, 'log', true ); ?>>Log</option>
						<option value="paper" <?php selected( $fribgi, 'paper', true ); ?>>Paper</option>
						<option value="stone" <?php selected( $fribgi, 'stone', true ); ?>>Stone</option>
					</select>
				</div>
				<div class="backgroundopts"><img class="img-preview" src="" alt=""></div>
				<div class="backgroundopts"><label>Padding <input type="text" class="small-text" name="fribgp" value="<?php echo $fribgp; ?>"></label></div>
				<div class="backgroundopts"><label>Opaque <input type="checkbox" name="fribgopacity" value="1" <?php checked( $fribgopacity, '1', true ); ?>></label></div>
				</td>
			</tr>
			<tr>
				<td><label>Text</label></td>
				<td>
				<div class="backgroundopts"><label>Color <input type="text" class="small-text color-picker" name="frtxtc" value="<?php echo $frtxtc; ?>"></label></div>
				</td>
			</tr>
		</table>
		<?php
}


function spp_lch_single_page_callback( $post ) {
	$all_spp_lch_popups = get_posts('post_type=spp_lch_popups&showposts=-1&orderby=name&order=ASC');
	$spp_lch_single_hide = get_post_meta( $post->ID, 'spp_lch_single_hide', true );
	$spp_lch_showthis = get_post_meta( $post->ID, 'spp_lch_showthis', true );
	wp_nonce_field( plugin_basename( __FILE__ ), 'spp_lch_nonce' );
	?>
	<p>
		<label for="spp_lch_single_hide">Disable Last Chance</label>
		<input type="checkbox" id="spp_lch_single_hide" name="spp_lch_single_hide" value="1" <?php checked( $spp_lch_single_hide, '1', true ); ?>>
	</p>
	<select name="spp_lch_showthis" >
		<option value="0">Default</option>
		<?php
		foreach( $all_spp_lch_popups as $single_post ){
		?>
			<option value="<?php echo $single_post->ID; ?>" <?php selected( $spp_lch_showthis, $single_post->ID, true ); ?>><?php echo $single_post->post_title; ?></option>
		<?php } ?>
	</select>
	<?php
}

add_action( 'save_post', 'spp_lch_save_postdata' );
function spp_lch_save_postdata( $post_id ) {
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;
  if ( !wp_verify_nonce( $_POST['spp_lch_nonce'], plugin_basename( __FILE__ ) ) )
      return;
  if ( 'page' == $_POST['post_type'] ) 
  {
    if ( !current_user_can( 'edit_page', $post_id ) )
        return;
  }
  else
  {
    if ( !current_user_can( 'edit_post', $post_id ) )
        return;
  }

 	// Gets all post types
	$post_types = get_post_types( array('public' => true) );
	unset($post_types['attachment'], $post_types['spp_lch_popups'] ); //Removes attachments from post_types array

  // Save post/page metabox
  if( in_array(get_post_type( $post_id ), $post_types) ){
  	// Validate/Sanitize
  	$spp_lch_single_hide = ( isset( $_POST['spp_lch_single_hide'] ) && $_POST['spp_lch_single_hide'] == '1' ) ? '1' : '' ;
  	$spp_lch_showthis = ( isset( $_POST['spp_lch_showthis'] ) && is_numeric( $_POST['spp_lch_showthis'] ) ) ? $_POST['spp_lch_showthis'] : '' ;
  
  	// Save values
	update_post_meta( $post_id, 'spp_lch_single_hide', $spp_lch_single_hide );
	update_post_meta( $post_id, 'spp_lch_showthis', $spp_lch_showthis );
  }

// Save custom post metabox
if( get_post_type( $post_id ) == 'spp_lch_popups'  ){
	// Allowed selection variables
	$allowed_style = array( 'solid', 'dotted', 'dashed' );
	$allowed_images = array( 'bokeh', 'flower', 'grass', 'log', 'paper', 'stone' );

   	// Validate/Sanitize first
	$frobs = ( isset( $_POST['frobs'] ) && is_numeric( $_POST['frobs'] ) ) ? $_POST['frobs'] : '' ;
	$frobc = ( isset( $_POST['frobc'] ) && preg_match( '/^#[a-f0-9]{6}$/i', $_POST['frobc'] ) == '1' ) ? $_POST['frobc'] : '' ;
	$frobstyle = ( isset( $_POST['frobstyle'] ) && in_array( $_POST['frobstyle'], $allowed_style ) ) ? $_POST['frobstyle'] : '' ;
	$frobgc = ( isset( $_POST['frobgc'] ) && preg_match( '/^#[a-f0-9]{6}$/i', $_POST['frobgc'] ) == '1' ) ? $_POST['frobgc'] : '' ;
	$frobgi = ( isset( $_POST['frobgi'] ) && in_array( $_POST['frobgi'], $allowed_images ) ) ? $_POST['frobgi'] : '0' ;
	$frobgp = ( isset( $_POST['frobgp'] ) ) ? sanitize_text_field( $_POST['frobgp'] ) : '0' ;
	$fribs = ( isset( $_POST['fribs'] ) && is_numeric( $_POST['fribs'] ) ) ? $_POST['fribs'] : '' ;
	$fribc = ( isset( $_POST['fribc'] ) && preg_match( '/^#[a-f0-9]{6}$/i', $_POST['fribc'] ) == '1' ) ? $_POST['fribc'] : '' ;
	$fribstyle = ( isset( $_POST['fribstyle'] ) && in_array( $_POST['fribstyle'], $allowed_style ) ) ? $_POST['fribstyle'] : '' ;
	$fribgc = ( isset( $_POST['fribgc'] ) && preg_match( '/^#[a-f0-9]{6}$/i', $_POST['fribgc'] ) == '1' ) ? $_POST['fribgc'] : '' ;
	$fribgi = ( isset( $_POST['fribgi'] ) && in_array( $_POST['fribgi'], $allowed_images ) ) ? $_POST['fribgi'] : '0' ;
	$fribgp = ( isset( $_POST['fribgp'] ) ) ? sanitize_text_field( $_POST['fribgp'] ) : '0' ;
	$fribgopacity = ( isset( $_POST['fribgopacity'] ) ) ? '1' : '' ;
	$frtxtc = ( isset( $_POST['frtxtc'] ) && preg_match( '/^#[a-f0-9]{6}$/i', $_POST['frtxtc'] ) == '1' ) ? $_POST['frtxtc'] : '' ;

	// Turn validated settings into array
   	$spp_lch_meta_array = array(
   		'frobs' => $frobs,
   		'frobc' => $frobc,
   		'frobstyle' => $frobstyle,
   		'frobgc' => $frobgc,
   		'frobgi' => $frobgi,
   		'frobgp' => $frobgp,
   		'fribs' => $fribs,
   		'fribc' => $fribc,
   		'fribstyle' => $fribstyle,
   		'fribgc' => $fribgc,
   		'fribgi' => $fribgi,
   		'fribgp' => $fribgp,
   		'fribgopacity' => $fribgopacity,
   		'frtxtc' => $frtxtc
   		);
   	// Then save
	update_post_meta( $post_id, '_spp_lch_post_meta', $spp_lch_meta_array );
	//print_r($spp_lch_meta_array);
	//exit();
  }
  
  
}

?>