<?php
// Enqueue front-facing scripts and styles
add_action('wp_enqueue_scripts', 'spp_lch_enqueue_front_scripts');
function spp_lch_enqueue_front_scripts(){	
	global $post;
	global $spp_lch_options;
	
	$spp_lch_localize_params = array(
		'cookie' => sanitize_text_field($spp_lch_options['cookie']),
		'cookie_duration' => sanitize_text_field($spp_lch_options['cookie_duration'])
	);
	
	// Check if cookie exists and whether to ignore
	if( !isset($_COOKIE['spp_lch_popups_hide']) || $spp_lch_options['cookie'] == 1 ) {
		if( is_front_page() && ( $spp_lch_options['home_lchpopup'] != 0 ) ){
			$to_show = 1;
		}
		
		if( ( is_archive() || is_category() ) && ( $spp_lch_options['archive_lchpopup'] != 0 ) ){
			$to_show = 1;
		}

		if ( is_single() && $spp_lch_options['default_lchpopup'] != '0' ) { // Is global ad on?
			if( get_post_meta( $post->ID, 'spp_lch_single_hide', true ) != '1' ) { // Is enabled on page
				$to_show = 1;
			}		
		}

		if ( is_page() && $spp_lch_options['page_lchpopup'] != '0' ) { // Is global ad on?
			if( get_post_meta( $post->ID, 'spp_lch_single_hide', true ) != '1' ) { // Is enabled on page
				$to_show = 1;
			}		
		}
	} // End Cookie check
	
	if( $to_show == 1 ) {	
		wp_enqueue_script('spp-lch-front', SPP_LCH_DIR.'/modules/js/front.min.js', array('jquery'), SPP_LCH_VERSION, true ) ;
		wp_enqueue_style('spp-lch-front', SPP_LCH_DIR.'/modules/css/front.min.css' ) ;
		wp_localize_script( 'spp-lch-front', 'spp_lch_localize_params', $spp_lch_localize_params );
	}
}

// Enqueue scripts for admin
add_action( 'admin_enqueue_scripts', 'spp_lch_admin_scripts', 10, 1 );
function spp_lch_admin_scripts( $hook ) {
  //global $post;
  global $typenow;

    wp_register_style( 'spp-lch-icon-admin', SPP_LCH_DIR.'/modules/css/libs/fontello/css/pm-lastchance.css','', false, 'all' );
    wp_enqueue_style( 'spp-lch-icon-admin' );

	if( 'spp_lch_popups' == $typenow ) {
	    wp_enqueue_script( 'spp_lch_admin', SPP_LCH_DIR.'/modules/js/admin.min.js', array('jquery', 'wp-color-picker'), false, true );
	    wp_enqueue_style( 'wp-color-picker' );
	    wp_register_style( 'spp-lch-admin', SPP_LCH_DIR.'/modules/css/admin.min.css','', false, 'all' );
    	wp_enqueue_style( 'spp-lch-admin' );
    	wp_enqueue_style( 'spp-lch-icon-admin' );
    	wp_localize_script( 'spp_lch_admin', 'spp_lch_admin_params', array( 'lch_dir' => SPP_LCH_DIR ) );
	}

	if( 'post-new.php' == $hook || 'post.php' == $hook ) {
	}

}
?>